/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

/* (1) Define the translation by string (do not insert directive) */
static String trans_list = "\
    Ctrl <Key> f   : forward-character() \n\
    Ctrl <Key> b   : backward-character() \n\
    <Key> osfRight : end-of-line() \n\
    <Key> osfLeft  : beginning-of-line()";

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, text;
    Arg     al[20];
    int     ac;
    XtTranslations trans_table;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Translation", NULL, 0,
                               &argc, argv, NULL, al, ac);

    /* (2) Compile the translation string into internal format */
    trans_table = XtParseTranslationTable(trans_list);

    ac = 0;
    text = XmCreateText(toplevel, "text", al, ac);
    XtManageChild(text);

    /* (3) Override the default translation of text widget
           by the new translation */
    XtOverrideTranslations(text, trans_table);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
